RaidIconBarData = {};

RaidIconBarData.targetonly = nil;
RaidIconBarData.scale = 1;
RaidIconBarData.border = nil;
RaidIconBarData.layout = nil;

-- Bindings
BINDING_HEADER_RIBHEADER = "RaidIconBar";
BINDING_NAME_RIBSNAP = "MouseSnap";

def_posx = 0;
def_posy = 0;

alwaysVisible = nil;

-- functions
function RaidIconBar_OnLoad()

 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffNirriti's |rRaidIconBar loaded.", 1.0, 1.0, 1.0, 1, 10);

 	this:RegisterEvent("ADDON_LOADED");
 	
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");

	SLASH_RAIDICONBAR1 = "/raidiconbar";
  	SLASH_RAIDICONBAR2 = "/rib";
  	SlashCmdList["RAIDICONBAR"] = function(msg)
		RaidIconBar_SlashCommandHandler(msg);
	end
 	
 	RaidIconBarFrame:SetClampedToScreen(true);
end

function RaidIconBar_OnEvent(self, event, ...)
	if (event == "PLAYER_ENTERING_WORLD" or
	    event == "PARTY_MEMBERS_CHANGED" or
	    event == "PLAYER_TARGET_CHANGED") then
	    RaidIconBar_CheckVisibility();
	end
	if (event == "ADDON_LOADED") then
	
		local addonName = ...;
		if (addonName == "RaidIconBar") then
	        RaidIconBar_InitScale();
	
            RaidIconBar_Reinit();
            RaidIconBar_CheckVisibility();
		end
	end
end

function RaidIconBar_SlashCommandHandler(msg)
	if (msg == "reload") then
	 	ReloadUI();
	end
	
	if (msg == "show") then
	 	alwaysVisible = 1;
	elseif (msg == "hide") then
	 	alwaysVisible = nil;
	elseif (msg == "always") then
	 	RaidIconBarData.targetonly = nil;
	elseif (msg == "targetonly") then
	 	RaidIconBarData.targetonly = 1;
	elseif (msg == "border") then
	 	if (RaidIconBarData.border) then
	 	    RaidIconBarData.border = nil;
	 	else
	 	    RaidIconBarData.border = 1;
	 	end
	elseif (msg == "reset") then
	 	RaidIconBar_ResetLayout();
	elseif (string.find(msg, "layout") == 1) then
		local str_index = string.sub(msg, 8);
		local index = tonumber(str_index);
		
		if (index and index >= 1 and index <= 9) then
		    RaidIconBarData.layout = index;
		elseif (RaidIconBarData.layout) then
	 	    RaidIconBarData.layout = RaidIconBarData.layout + 1;
	 	    if (RaidIconBarData.layout > 9) then
	 	        RaidIconBarData.layout = 1;
	 	    end
	 	else
	 	    RaidIconBarData.layout = 1;
	 	end
	 	
 	    DEFAULT_CHAT_FRAME:AddMessage("RaidIconBar: set layout to "..RaidIconBarData.layout, 1.0, 1.0, 1.0, 1, 10);
    
	elseif (string.find(msg, "scale") == 1) then
		local str_scale = string.sub(msg, 7);
		local scale = tonumber(str_scale);
		
		if (scale and scale >= 0.1 and scale <= 4) then
            RaidIconBarData.scale = scale;
            RaidIconBar_InitScale();
	 	end
	end
	
	RaidIconBar_Reinit();
	RaidIconBar_CheckVisibility();
end

function RaidIconBar_InitScale()
    local frame = getglobal("RaidIconBarFrame");
    
    if (RaidIconBarData.scale == nil) then
        RaidIconBarData.scale = 1;
    end
	 	
    frame:SetScale(RaidIconBarData.scale);
end

function RaidIconBar_OnClick(self, button, down)

    local id = this:GetID();
    
    if (id == 9) then
        DoReadyCheck();
    else
	    if (button == "LeftButton") then
   	    	SetRaidTarget("target", id);
	    elseif (button == "RightButton") then
	    	SetRaidTarget("target", 0);
	    end
	end
end

function RaidIconBar_ResetLayout()    
    RaidIconBarFrame:SetWidth(230);
    RaidIconBarFrame:SetHeight(40);
    
    RaidIconBarButton1:ClearAllPoints();
    RaidIconBarButton1:SetPoint("CENTER", -94, 0);
    RaidIconBarButton2:ClearAllPoints();
    RaidIconBarButton2:SetPoint("CENTER", -67, 0);
    RaidIconBarButton3:ClearAllPoints();
    RaidIconBarButton3:SetPoint("CENTER", -40, 0);
    RaidIconBarButton4:ClearAllPoints();
    RaidIconBarButton4:SetPoint("CENTER", -13, 0);
    RaidIconBarButton5:ClearAllPoints();
    RaidIconBarButton5:SetPoint("CENTER", 13, 0);
    RaidIconBarButton6:ClearAllPoints();
    RaidIconBarButton6:SetPoint("CENTER", 40, 0);
    RaidIconBarButton7:ClearAllPoints();
    RaidIconBarButton7:SetPoint("CENTER", 67, 0);
    RaidIconBarButton8:ClearAllPoints();
    RaidIconBarButton8:SetPoint("CENTER", 94, 0);
    RaidIconBarButton9:ClearAllPoints();
    RaidIconBarButton9:SetPoint("CENTER", 130, 0);
    
    RaidIconBarData.layout = nil;
end

function RaidIconBar_Reinit()
	local frame = getglobal("RaidIconBarFrame");
	
    if (RaidIconBarData.border) then
        frame:SetBackdrop( { 
            bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    else
        frame:SetBackdrop(nil);
    end
 	
 	RaidIconBar_LoadLayout(RaidIconBarData.layout);
end

function RaidIconBar_LoadLayout(index)
 	
    if (not index) then
        index = 1;
    end

    RaidIconBarButton1:ClearAllPoints();
    RaidIconBarButton2:ClearAllPoints();
    RaidIconBarButton3:ClearAllPoints();
    RaidIconBarButton4:ClearAllPoints();
    RaidIconBarButton5:ClearAllPoints();
    RaidIconBarButton6:ClearAllPoints();
    RaidIconBarButton7:ClearAllPoints();
    RaidIconBarButton8:ClearAllPoints();
    RaidIconBarButton9:ClearAllPoints();
    
    if (index == 1) then   
        RaidIconBarFrame:SetWidth(230);
        RaidIconBarFrame:SetHeight(40);
        
        RaidIconBar_ResetLayout();
    elseif (index == 2) then  
        RaidIconBarFrame:SetWidth(230);
        RaidIconBarFrame:SetHeight(40);
        
        RaidIconBarButton1:SetPoint("CENTER", 94, 0);
        RaidIconBarButton2:SetPoint("CENTER", 67, 0);
        RaidIconBarButton3:SetPoint("CENTER", 40, 0);
        RaidIconBarButton4:SetPoint("CENTER", 13, 0);
        RaidIconBarButton5:SetPoint("CENTER", -13, 0);
        RaidIconBarButton6:SetPoint("CENTER", -40, 0);
        RaidIconBarButton7:SetPoint("CENTER", -67, 0);
        RaidIconBarButton8:SetPoint("CENTER", -94, 0);
        
        RaidIconBarButton9:SetPoint("CENTER", -130, 0);
    elseif (index == 3) then
        RaidIconBarFrame:SetWidth(120);
        RaidIconBarFrame:SetHeight(70);
        
        RaidIconBarButton1:SetPoint("CENTER", -40, -13);
        RaidIconBarButton2:SetPoint("CENTER", -13, -13);
        RaidIconBarButton3:SetPoint("CENTER", 13, -13);
        RaidIconBarButton4:SetPoint("CENTER", 40, -13);
        RaidIconBarButton5:SetPoint("CENTER", -40, 13);
        RaidIconBarButton6:SetPoint("CENTER", -13, 13);
        RaidIconBarButton7:SetPoint("CENTER", 13, 13);
        RaidIconBarButton8:SetPoint("CENTER", 40, 13);
        
        RaidIconBarButton9:SetPoint("CENTER", 70, 0);
    elseif (index == 4) then
        RaidIconBarFrame:SetWidth(120);
        RaidIconBarFrame:SetHeight(70);
        
        RaidIconBarButton1:SetPoint("CENTER", 40, -13);
        RaidIconBarButton2:SetPoint("CENTER", 13, -13);
        RaidIconBarButton3:SetPoint("CENTER", -13, -13);
        RaidIconBarButton4:SetPoint("CENTER", -40, -13);
        RaidIconBarButton5:SetPoint("CENTER", 40, 13);
        RaidIconBarButton6:SetPoint("CENTER", 13, 13);
        RaidIconBarButton7:SetPoint("CENTER", -13, 13);
        RaidIconBarButton8:SetPoint("CENTER", -40, 13);
        
        RaidIconBarButton9:SetPoint("CENTER", -70, 0);
    elseif (index == 5) then
        RaidIconBarFrame:SetWidth(95);
        RaidIconBarFrame:SetHeight(95);
        
        RaidIconBarButton1:SetPoint("CENTER", 0, -27);
        RaidIconBarButton2:SetPoint("CENTER", -27, -27);
        RaidIconBarButton3:SetPoint("CENTER", 27, 0);
        RaidIconBarButton4:SetPoint("CENTER", 0, 0);
        RaidIconBarButton5:SetPoint("CENTER", -27, 0);
        RaidIconBarButton6:SetPoint("CENTER", 27, 27);
        RaidIconBarButton7:SetPoint("CENTER", 0, 27);
        RaidIconBarButton8:SetPoint("CENTER", -27, 27);
        
        RaidIconBarButton9:SetPoint("CENTER", 27, -27);
    elseif (index == 6) then
        RaidIconBarFrame:SetWidth(40);
        RaidIconBarFrame:SetHeight(230);
        
        RaidIconBarButton1:SetPoint("CENTER", 0, 94);
        RaidIconBarButton2:SetPoint("CENTER", 0, 67);
        RaidIconBarButton3:SetPoint("CENTER", 0, 40);
        RaidIconBarButton4:SetPoint("CENTER", 0, 13);
        RaidIconBarButton5:SetPoint("CENTER", 0, -13);
        RaidIconBarButton6:SetPoint("CENTER", 0, -40);
        RaidIconBarButton7:SetPoint("CENTER", 0, -67);
        RaidIconBarButton8:SetPoint("CENTER", 0, -94);
        
        RaidIconBarButton9:SetPoint("CENTER", 0, -130);
    elseif (index == 7) then  
        RaidIconBarFrame:SetWidth(40);
        RaidIconBarFrame:SetHeight(230);
        
        RaidIconBarButton1:SetPoint("CENTER", 0, -94);
        RaidIconBarButton2:SetPoint("CENTER", 0, -67);
        RaidIconBarButton3:SetPoint("CENTER", 0, -40);
        RaidIconBarButton4:SetPoint("CENTER", 0, -13);
        RaidIconBarButton5:SetPoint("CENTER", 0, 13);
        RaidIconBarButton6:SetPoint("CENTER", 0, 40);
        RaidIconBarButton7:SetPoint("CENTER", 0, 67);
        RaidIconBarButton8:SetPoint("CENTER", 0, 94);
        
        RaidIconBarButton9:SetPoint("CENTER", 0, 130);
    elseif (index == 8) then
        RaidIconBarFrame:SetWidth(70);
        RaidIconBarFrame:SetHeight(120);
        
        RaidIconBarButton1:SetPoint("CENTER", -13, -40);
        RaidIconBarButton2:SetPoint("CENTER", -13, -13);
        RaidIconBarButton3:SetPoint("CENTER", -13, 13);
        RaidIconBarButton4:SetPoint("CENTER", -13, 40);
        RaidIconBarButton5:SetPoint("CENTER", 13, -40);
        RaidIconBarButton6:SetPoint("CENTER", 13, -13);
        RaidIconBarButton7:SetPoint("CENTER", 13, 13);
        RaidIconBarButton8:SetPoint("CENTER", 13, 40);
        
        RaidIconBarButton9:SetPoint("CENTER", 0, 70);
    elseif (index == 9) then
        RaidIconBarFrame:SetWidth(70);
        RaidIconBarFrame:SetHeight(120);
        
        RaidIconBarButton1:SetPoint("CENTER", -13, 40);
        RaidIconBarButton2:SetPoint("CENTER", -13, 13);
        RaidIconBarButton3:SetPoint("CENTER", -13, -13);
        RaidIconBarButton4:SetPoint("CENTER", -13, -40);
        RaidIconBarButton5:SetPoint("CENTER", 13, 40);
        RaidIconBarButton6:SetPoint("CENTER", 13, 13);
        RaidIconBarButton7:SetPoint("CENTER", 13, -13);
        RaidIconBarButton8:SetPoint("CENTER", 13, -40);
        
        RaidIconBarButton9:SetPoint("CENTER", 0, -70);
    else
        RaidIconBar_ResetLayout();
    end
end

function RaidIconBar_CheckVisibility()
	local frame = getglobal("RaidIconBarFrame");
 	    
	if (RaidIconBarData.targetonly == 1 and UnitExists("target") == nil and not alwaysVisible) then
		frame:Hide();
		return;
	end
	
	if (not alwaysVisible) then
   		if (frame) then
   			if (GetNumRaidMembers() > 0) then
   				if ( IsRaidOfficer() or IsRaidLeader() ) then
      		        frame:Show();
     			else
     				frame:Hide();
    			end
    	    else
      		    frame:Show();
   			end
   		end
   	else
   		frame:Show();
  	end
  	
  	local rc_button = getglobal("RaidIconBarButton9");
  	
  	if ( IsPartyLeader() or IsRaidOfficer() or IsRaidLeader()) then
  	    rc_button:Show();
  	else
  	    rc_button:Hide();
  	end
  	
  	--rc_button:Show();
end

function RaidIconBar_SnapDown()
	local frame = getglobal("RaidIconBarFrame");
	
	def_posx = frame:GetLeft();
	def_posy = frame:GetBottom();
	
	local x, y = GetCursorPosition();
	local scale = UIParent:GetEffectiveScale();
	
	x = x / scale / RaidIconBarData.scale;	
	y = y / scale / RaidIconBarData.scale;
	
	local frame = getglobal("RaidIconBarFrame");
	frame:ClearAllPoints();
	frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x, y);
end

function RaidIconBar_SnapUp()
	local frame = getglobal("RaidIconBarFrame");
	frame:ClearAllPoints();
	frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", def_posx, def_posy);
end